searchNodes=[{"doc":"NOTE: This package is still under active development and may be refactored in substantive ways very soon. If you need to get to prod soon, you may want to find an alternative. CloudflareApi is a thin wrapper around the Cloudflare API. It provides convenient functions and elixir idioms so you don't have to use HTTP directly. This library subscribes to the philosophy that you a well-designed REST API doesn't need a heavy layer of abstraction on top. There is extensive documentation for the CloudFlare API already, and abstracting that away . The downside of course is that if you want to be shielded from the API details, this isn't the package for you. For example, if you wanted to call the Cloudflare endpoint for listing DNS records : GET zones / :zone_identifier / dns_records rather than using one of the many HTTP clients, you can do: CloudflareApi.DnsRecords . list ( client , zone_id ) The extensive query string prameters options that CloudFlare offers are also accessible through an opts KeywordList : CloudflareApi.DnsRecords . list ( client , zone_id , name : hostname , type : &quot;A&quot; ) You may wish to look through the Livebook for an example of usage. NOTE: This package is still very new and is far from feature complete. The most common endpoints will be created first, but if you need one that isn't provided yet you can open an issue on Github (or send a pull request). Because this layer is very thin, it doesn't usually take long to add new endpoints.","ref":"CloudflareApi.html","title":"CloudflareApi","type":"module"},{"doc":"Returns a function that you can use to easily pass clients in your code. This makes it so you don't have to create your own client for every function call. If you are going to make multiple calls then this is recommended for convenience and simplicity. For example: # Get a function that wraps your token for you client = CloudflareApi . client ( &quot;&lt;my_token&gt;&quot; ) # Now you can call other functions like this: CloudflareApi.DnsRecords . list ( client ( ) , &quot;my_zone_id) # If you are going to do additional processing, you can use a pipe: client(api_token) |&gt; CloudflareApi.list(&quot; my_zone_id &quot; ) |&gt; Enum . map ( fn record -&gt; { record } end )","ref":"CloudflareApi.html#client/1","title":"CloudflareApi.client/1","type":"function"},{"doc":"Get a preconfigured client you can pass in to other functions This makes it so that you don't have to provide the cloudflare_api_token to every function call. Examples: iex&gt; CloudflareApi.new(&quot;&lt;your_token&gt;&quot;)","ref":"CloudflareApi.html#new/1","title":"CloudflareApi.new/1","type":"function"},{"doc":"Makes a struct and convenience functions around A Cloudflare DNS record. See Cloudflare docs: https://api.cloudflare.com/#dns-records-for-a-zone-properties","ref":"CloudflareApi.DnsRecord.html","title":"CloudflareApi.DnsRecord","type":"module"},{"doc":"","ref":"CloudflareApi.DnsRecord.html#cf_url/1","title":"CloudflareApi.DnsRecord.cf_url/1","type":"function"},{"doc":"","ref":"CloudflareApi.DnsRecord.html#from_cf_json/1","title":"CloudflareApi.DnsRecord.from_cf_json/1","type":"function"},{"doc":"","ref":"CloudflareApi.DnsRecord.html#to_cf_json/1","title":"CloudflareApi.DnsRecord.to_cf_json/1","type":"function"},{"doc":"","ref":"CloudflareApi.DnsRecords.html","title":"CloudflareApi.DnsRecords","type":"module"},{"doc":"If the record already exists, this will exit with a success {:ok, :already_created}","ref":"CloudflareApi.DnsRecords.html#create/3","title":"CloudflareApi.DnsRecords.create/3","type":"function"},{"doc":"","ref":"CloudflareApi.DnsRecords.html#create/5","title":"CloudflareApi.DnsRecords.create/5","type":"function"},{"doc":"If the record already exists, this will exit with a success {:ok, :already_deleted}","ref":"CloudflareApi.DnsRecords.html#delete/3","title":"CloudflareApi.DnsRecords.delete/3","type":"function"},{"doc":"","ref":"CloudflareApi.DnsRecords.html#hostname_exists?/4","title":"CloudflareApi.DnsRecords.hostname_exists?/4","type":"function"},{"doc":"","ref":"CloudflareApi.DnsRecords.html#list/3","title":"CloudflareApi.DnsRecords.list/3","type":"function"},{"doc":"","ref":"CloudflareApi.DnsRecords.html#list_for_host_domain/5","title":"CloudflareApi.DnsRecords.list_for_host_domain/5","type":"function"},{"doc":"","ref":"CloudflareApi.DnsRecords.html#list_for_hostname/4","title":"CloudflareApi.DnsRecords.list_for_hostname/4","type":"function"},{"doc":"","ref":"CloudflareApi.DnsRecords.html#update/6","title":"CloudflareApi.DnsRecords.update/6","type":"function"},{"doc":"","ref":"CloudflareApi.Utils.html","title":"CloudflareApi.Utils","type":"module"},{"doc":"Macro that makes a function public in test, private in non-test See: https://stackoverflow.com/a/47598190/2062384","ref":"CloudflareApi.Utils.html#defp_testable/2","title":"CloudflareApi.Utils.defp_testable/2","type":"macro"},{"doc":"Quick regex check to see if the supplied string is a valid UUID Check is done by simple regular expression and is not overly sophisticated. Return true || false Examples iex&gt; CloudflareApi.Utils . is_uuid? ( nil ) false iex&gt; CloudflareApi.Utils . is_uuid? ( &quot;hello world&quot; ) false iex&gt; CloudflareApi.Utils . is_uuid? ( &quot;4c2fd8d3-a6e3-4e4b-a2ce-3f21456eeb85&quot; ) true","ref":"CloudflareApi.Utils.html#is_uuid?/1","title":"CloudflareApi.Utils.is_uuid?/1","type":"function"},{"doc":"","ref":"CloudflareApi.Utils.html#is_uuid_or_nil?/1","title":"CloudflareApi.Utils.is_uuid_or_nil?/1","type":"function"},{"doc":"Takes a list of strings or atoms and returns a list with string and atoms. Examples iex&gt; list_to_strings_and_atoms ( [ :circle ] ) [ :circle , &quot;circle&quot; ] iex&gt; list_to_strings_and_atoms ( [ :circle , :square ] ) [ :square , &quot;square&quot; , :circle , &quot;circle&quot; ] iex&gt; list_to_strings_and_atoms ( [ &quot;circle&quot; , &quot;square&quot; ] ) [ &quot;square&quot; , :square , &quot;circle&quot; , :circle ]","ref":"CloudflareApi.Utils.html#list_to_strings_and_atoms/1","title":"CloudflareApi.Utils.list_to_strings_and_atoms/1","type":"function"},{"doc":"Convert a map with String keys into a map with Atom keys. Examples iex&gt; CloudflareApi.Utils . map_atom_keys_to_strings ( %{ one : &quot;one&quot; , two : &quot;two&quot; } ) %{ &quot;one&quot; =&gt; &quot;one&quot; , &quot;two&quot; =&gt; &quot;two&quot; }","ref":"CloudflareApi.Utils.html#map_atom_keys_to_strings/1","title":"CloudflareApi.Utils.map_atom_keys_to_strings/1","type":"function"},{"doc":"Convert a map with String keys into a map with Atom keys. Examples iex&gt; CloudflareApi.Utils . map_string_keys_to_atoms ( %{ &quot;one&quot; =&gt; &quot;one&quot; , &quot;two&quot; =&gt; &quot;two&quot; } ) %{ one : &quot;one&quot; , two : &quot;two&quot; } m","ref":"CloudflareApi.Utils.html#map_string_keys_to_atoms/1","title":"CloudflareApi.Utils.map_string_keys_to_atoms/1","type":"function"},{"doc":"Convert a map to a String , suitable for printing. Optionally pass a list of keys to mask. Examples iex&gt; map_to_string ( %{ michael : &quot;knight&quot; } ) &quot;michael: &#39;knight&#39;&quot; iex&gt; map_to_string ( %{ michael : &quot;knight&quot; , kitt : &quot;karr&quot; } ) &quot;kitt: &#39;karr&#39;, michael: &#39;knight&#39;&quot; iex&gt; map_to_string ( %{ michael : &quot;knight&quot; , kitt : &quot;karr&quot; } , [ :kitt ] ) &quot;kitt: &#39;****&#39;, michael: &#39;knight&#39;&quot; iex&gt; map_to_string ( %{ michael : &quot;knight&quot; , kitt : &quot;karr&quot; } , [ :kitt , :michael ] ) &quot;kitt: &#39;****&#39;, michael: &#39;******&#39;&quot; iex&gt; map_to_string ( %{ &quot;michael&quot; =&gt; &quot;knight&quot; , &quot;kitt&quot; =&gt; &quot;karr&quot; , &quot;carr&quot; =&gt; &quot;hart&quot; } , [ &quot;kitt&quot; , &quot;michael&quot; ] ) &quot;carr: &#39;hart&#39;, kitt: &#39;****&#39;, michael: &#39;******&#39;&quot;","ref":"CloudflareApi.Utils.html#map_to_string/2","title":"CloudflareApi.Utils.map_to_string/2","type":"function"},{"doc":"Checks if the passed item is nil or empty string. The param will be passed to to_string() and then String.trim() and checked for empty string Examples iex&gt; CloudflareApi.Utils . nil_or_empty? ( &quot;hello&quot; ) false iex&gt; CloudflareApi.Utils . nil_or_empty? ( &quot;&quot; ) true iex&gt; CloudflareApi.Utils . nil_or_empty? ( nil ) true","ref":"CloudflareApi.Utils.html#nil_or_empty?/1","title":"CloudflareApi.Utils.nil_or_empty?/1","type":"function"},{"doc":"Easy drop-in to a pipe to inspect the return value of the previous function. Examples conn |&gt; put_status ( :not_found ) |&gt; put_view ( CloudflareApiWeb.ErrorView ) |&gt; render ( :&quot;404&quot; ) |&gt; pry_pipe ( )","ref":"CloudflareApi.Utils.html#pry_pipe/5","title":"CloudflareApi.Utils.pry_pipe/5","type":"function"},{"doc":"if value (value of the argument) is nil, this will raise CloudflareApi.CantBeNil argn (name of the argument) will be passed to allow for more helpful error messages that tell you the name of the variable that was nil Examples iex&gt; CloudflareApi.Utils . raise_if_nil! ( &quot;someval&quot; ) &quot;someval&quot; iex&gt; CloudflareApi.Utils . raise_if_nil! ( nil ) ** (CloudflareApi.CantBeNil) variable &#39;somevar&#39; was nil but cannot be (malan 0.1.0) lib/malan/utils.ex:142: CloudflareApi.Utils.raise_if_nil!/1","ref":"CloudflareApi.Utils.html#raise_if_nil!/1","title":"CloudflareApi.Utils.raise_if_nil!/1","type":"function"},{"doc":"if value (value of the argument) is nil, this will raise CloudflareApi.CantBeNil argn (name of the argument) will be passed to allow for more helpful error messages that tell you the name of the variable that was nil Examples iex&gt; CloudflareApi.Utils . raise_if_nil! ( &quot;somevar&quot; , &quot;someval&quot; ) &quot;someval&quot; iex&gt; CloudflareApi.Utils . raise_if_nil! ( &quot;somevar&quot; , nil ) ** (CloudflareApi.CantBeNil) variable &#39;somevar&#39; was nil but cannot be (malan 0.1.0) lib/malan/utils.ex:135: CloudflareApi.Utils.raise_if_nil!/2","ref":"CloudflareApi.Utils.html#raise_if_nil!/2","title":"CloudflareApi.Utils.raise_if_nil!/2","type":"function"},{"doc":"Converts a struct to a regular map by deleting the :__meta__ key Examples CloudflareApi.Utils . struct_to_map ( % Something { hello : &quot;world&quot; } ) %{ hello : &quot;world&quot; }","ref":"CloudflareApi.Utils.html#struct_to_map/1","title":"CloudflareApi.Utils.struct_to_map/1","type":"function"},{"doc":"Generate a new UUIDv4 Examples CloudflareApi.Utils . uuidgen ( ) &quot;4c2fd8d3-a6e3-4e4b-a2ce-3f21456eeb85&quot;","ref":"CloudflareApi.Utils.html#uuidgen/0","title":"CloudflareApi.Utils.uuidgen/0","type":"function"},{"doc":"","ref":"CloudflareApi.Utils.Crypto.html","title":"CloudflareApi.Utils.Crypto","type":"module"},{"doc":"","ref":"CloudflareApi.Utils.Crypto.html#fake_verify_password/0","title":"CloudflareApi.Utils.Crypto.fake_verify_password/0","type":"function"},{"doc":"","ref":"CloudflareApi.Utils.Crypto.html#hash_password/1","title":"CloudflareApi.Utils.Crypto.hash_password/1","type":"function"},{"doc":"","ref":"CloudflareApi.Utils.Crypto.html#hash_token/1","title":"CloudflareApi.Utils.Crypto.hash_token/1","type":"function"},{"doc":"","ref":"CloudflareApi.Utils.Crypto.html#strong_random_string/1","title":"CloudflareApi.Utils.Crypto.strong_random_string/1","type":"function"},{"doc":"","ref":"CloudflareApi.Utils.Crypto.html#verify_password/2","title":"CloudflareApi.Utils.Crypto.verify_password/2","type":"function"},{"doc":"","ref":"CloudflareApi.Utils.DateTime.html","title":"CloudflareApi.Utils.DateTime","type":"module"},{"doc":"Add the specified number of units to the current time. Supplying a negative number will adjust the time backwards by the specified units, while supplying a positive will adjust the time forwards by the specified units.","ref":"CloudflareApi.Utils.DateTime.html#adjust_cur_time/2","title":"CloudflareApi.Utils.DateTime.adjust_cur_time/2","type":"function"},{"doc":"","ref":"CloudflareApi.Utils.DateTime.html#adjust_cur_time_trunc/2","title":"CloudflareApi.Utils.DateTime.adjust_cur_time_trunc/2","type":"function"},{"doc":"","ref":"CloudflareApi.Utils.DateTime.html#adjust_time/3","title":"CloudflareApi.Utils.DateTime.adjust_time/3","type":"function"},{"doc":"Return a DateTime about 200 years into the future","ref":"CloudflareApi.Utils.DateTime.html#distant_future/0","title":"CloudflareApi.Utils.DateTime.distant_future/0","type":"function"},{"doc":"","ref":"CloudflareApi.Utils.DateTime.html#expired?/1","title":"CloudflareApi.Utils.DateTime.expired?/1","type":"function"},{"doc":"","ref":"CloudflareApi.Utils.DateTime.html#expired?/2","title":"CloudflareApi.Utils.DateTime.expired?/2","type":"function"},{"doc":"Check if past_time occurs before the current time","ref":"CloudflareApi.Utils.DateTime.html#in_the_past?/1","title":"CloudflareApi.Utils.DateTime.in_the_past?/1","type":"function"},{"doc":"Check if past_time occurs before current_time . Equal date returns true","ref":"CloudflareApi.Utils.DateTime.html#in_the_past?/2","title":"CloudflareApi.Utils.DateTime.in_the_past?/2","type":"function"},{"doc":"","ref":"CloudflareApi.Utils.DateTime.html#utc_now_trunc/0","title":"CloudflareApi.Utils.DateTime.utc_now_trunc/0","type":"function"},{"doc":"","ref":"CloudflareApi.Utils.Enum.html","title":"CloudflareApi.Utils.Enum","type":"module"},{"doc":"will return true if all invocations of the function return false. If one callback returns true , the end result will be false Enum.all? will return true if all invocations of the function return true. CloudflareApi.Utils.Enum.none? is the opposite.","ref":"CloudflareApi.Utils.Enum.html#none?/2","title":"CloudflareApi.Utils.Enum.none?/2","type":"function"},{"doc":"Makes a struct and convenience functions around A Cloudflare Zone object. See Cloudflare docs: https://api.cloudflare.com/#zone-properties","ref":"CloudflareApi.Zone.html","title":"CloudflareApi.Zone","type":"module"},{"doc":"","ref":"CloudflareApi.Zone.html#cf_url/1","title":"CloudflareApi.Zone.cf_url/1","type":"function"},{"doc":"","ref":"CloudflareApi.Zone.html#from_cf_json/1","title":"CloudflareApi.Zone.from_cf_json/1","type":"function"},{"doc":"","ref":"CloudflareApi.Zone.html#to_cf_json/1","title":"CloudflareApi.Zone.to_cf_json/1","type":"function"},{"doc":"","ref":"CloudflareApi.Zones.html","title":"CloudflareApi.Zones","type":"module"},{"doc":"","ref":"CloudflareApi.Zones.html#list/2","title":"CloudflareApi.Zones.list/2","type":"function"}]